pipeline {
    agent any
    environment {
        MINOR_VALUE = '0'
        MAJOR_VALUE = '1'
        version = "${MINOR_VALUE}.${MAJOR_VALUE}.${BUILD_NUMBER}"
    }
    stages {
        stage('Docker Login And Push') {
           when{
                expression{
                    BRANCH_NAME == 'Dev'
                }
            }
            
            steps {
                script {
                    sh "docker login -u ${DOCKER_HUB_USERNAME} -p ${DOCKER_HUB_PASSWORD}"
                    sh "docker build -t snkdeep/python:${env.version} ."
                    sh "docker push snkdeep/python:${env.version}"
                }
            }
        }
        stage('Docker Pull') {
           when{
                  expression{
                    BRANCH_NAME == 'Dev'
                }
            }
            steps {
                script {
                    sh "docker stop python-container"
                    sh "docker rm python-container"
                    sh "docker pull snkdeep/python:${env.version}"
                    sh "docker run --name python-container snkdeep/python:${env.version}"
                }
            }
        }
    }
}



